//+------------------------------------------------------------------+
//|                                                      signal .mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 0
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//
 
extern int win = 0;
extern int price.x.offset= 47 ; 
extern int price.y.offset= 30 ; 

extern int   myFontSize       = 14;

extern string noteTimeNY = " 14:00 server time = 05:00 mst" ; 
extern string noteTimeAU = " 23:00 server time = 14:00 mst" ; 
extern string noteTimeLD = " 09:00 server time = 00:00 mst" ; 

extern string myHHMM       = "13:00"; // 05:00 am pst = 14:00 server time 
extern string myMessage    = "NY" ; 

extern string Buy_Message  = "BUY SIGNAL" ;
extern string Wait_Message = "WAIT FOR SIGNAL" ;
extern string Sell_Message = "SELL SIGNAL" ;
extern string Rdy_Message  = "READY TO ENTER" ;

extern color Buy_color     = Lime;
extern color Wait_color    = PaleVioletRed;
extern color Sell_color    = Red;
extern color Rdy_color     = Aqua;

extern bool alertsOn      = true;
extern bool alertsMessage = true;
extern bool alertsSound   = false;
extern bool alertsEmail   = false;

//
//
//
//
//

double state[];
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{ 
   IndicatorBuffers(1);
      SetIndexBuffer(0,state); SetIndexStyle(0,DRAW_NONE);
      return(0); 
} 
int deinit() { ObjectDelete("TRAIN31"); return(0); }  
 
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      color ClOpColor;
      string tMessage;
      
         for(int i=limit; i>=0; i--)
         {
            double DailyOpen = DoDailyOpen(i);
            double H1_open   = iOpen(NULL,PERIOD_H1,iBarShift(NULL,PERIOD_H1,Time[i]));
            double close     = Close[i];   
            double open      = Open[i];

            state[i] = 0;
               if (close>open && close>DailyOpen && close>H1_open) state[i] =  1;
               if (close<open && close<DailyOpen && close<H1_open) state[i] = -1;
         }

   //
   //
   //
   //
   //
                       
      if (state[0] == -1) { tMessage = Sell_Message; ClOpColor = Sell_color; }
      if (state[0] ==  1) { tMessage = Buy_Message;  ClOpColor = Buy_color;  }
      if (state[0] ==  0) { tMessage = Wait_Message; ClOpColor = Wait_color; }

      ObjectCreate("TRAIN31", OBJ_LABEL,win,0,0);
         ObjectSet("TRAIN31", OBJPROP_CORNER,0);
         ObjectSet("TRAIN31", OBJPROP_XDISTANCE, price.x.offset); 
         ObjectSet("TRAIN31", OBJPROP_YDISTANCE, price.y.offset); 
         ObjectSetText("TRAIN31",tMessage, myFontSize , "Segoe Print", ClOpColor );
   
         //
         //
         //
         //
         //
               
         if (alertsOn)
         { 
            if (state[0] != state[1] && state[0]!=0)
            {
               doAlert(0,tMessage);
            }                                     
         }                  
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double DoDailyOpen(int i) 
{
   int   yy = TimeYear(Time[i]);
   int   mm = TimeMonth(Time[i]);
   int   dd = TimeDay(Time[i]);  
   
   string yymmddms = yy+"."+mm+"."+dd+" " + myHHMM ;
         
      datetime var1 = StrToTime(yymmddms);  
      datetime day  = 24*60*60;
      datetime r    = var1 ;

      int      cd=iBarShift(NULL,0,r,FALSE);
      datetime r2=r-day;

         if(TimeDayOfWeek(r2)==0) r2=r2-day-day;
         int cd2=iBarShift(NULL,0,r2,FALSE);

         if( var1 > Time[i] ) { r = r2 ;cd = cd2 ;} // if date/time is greater than current date/time go back 1 day
   return(Open[cd]);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   

   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," signal ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"signal"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}